org.apache.poi.poifs.crypt.binaryrc4

## Class BinaryRC4Encryptor.BinaryRC4CipherOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - java.io.FilterOutputStream
    - - org.apache.poi.poifs.crypt.ChunkedCipherOutputStream
      - - org.apache.poi.poifs.crypt.binaryrc4.BinaryRC4Encryptor.BinaryRC4CipherOutputStream

- All Implemented Interfaces:
    java.io.Closeable, java.io.Flushable, java.lang.AutoCloseable
  Enclosing class:
    BinaryRC4Encryptor

      protected class BinaryRC4Encryptor.BinaryRC4CipherOutputStream
      extends ChunkedCipherOutputStream

- - ### Field Summary

    - ### Fields inherited from class java.io.FilterOutputStream

      `out`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BinaryRC4CipherOutputStream(DirectoryNode dir)`
    `BinaryRC4CipherOutputStream(java.io.OutputStream stream)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `calculateChecksum(java.io.File file, int i)`
    `protected void` | `createEncryptionInfoEntry(DirectoryNode dir, java.io.File tmpFile)`
    `void` | `flush()`
    `protected javax.crypto.Cipher` | `initCipherForBlock(javax.crypto.Cipher cipher, int block, boolean lastChunk)`

    - ### Methods inherited from class org.apache.poi.poifs.crypt.ChunkedCipherOutputStream

      `close, getChunk, getChunkMask, getPlainByteFlags, getPos, getTotalPos, initCipherForBlock, initCipherForBlockNoFlush, invokeCipher, setNextRecordSize, write, write, write, write, writeChunk, writePlain`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BinaryRC4CipherOutputStream

          public BinaryRC4CipherOutputStream(java.io.OutputStream stream)
                                      throws java.io.IOException,
                                             java.security.GeneralSecurityException

      Throws:
        `java.io.IOException`
        `java.security.GeneralSecurityException`

    - #### BinaryRC4CipherOutputStream

          public BinaryRC4CipherOutputStream(DirectoryNode dir)
                                      throws java.io.IOException,
                                             java.security.GeneralSecurityException

      Throws:
        `java.io.IOException`
        `java.security.GeneralSecurityException`

  - ### Method Detail

    - #### initCipherForBlock

          protected javax.crypto.Cipher initCipherForBlock(javax.crypto.Cipher cipher,
                                                           int block,
                                                           boolean lastChunk)
                                                    throws java.security.GeneralSecurityException

      Specified by:
        `initCipherForBlock` in class `ChunkedCipherOutputStream`
      Throws:
        `java.security.GeneralSecurityException`

    - #### calculateChecksum

          protected void calculateChecksum(java.io.File file,
                                           int i)

      Specified by:
        `calculateChecksum` in class `ChunkedCipherOutputStream`

    - #### createEncryptionInfoEntry

          protected void createEncryptionInfoEntry(DirectoryNode dir,
                                                   java.io.File tmpFile)
                                            throws java.io.IOException,
                                                   java.security.GeneralSecurityException

      Specified by:
        `createEncryptionInfoEntry` in class `ChunkedCipherOutputStream`
      Throws:
        `java.io.IOException`
        `java.security.GeneralSecurityException`

    - #### flush

          public void flush()
                     throws java.io.IOException

      Specified by:
        `flush` in interface `java.io.Flushable`
      Overrides:
        `flush` in class `java.io.FilterOutputStream`
      Throws:
        `java.io.IOException`

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.